package TC2;

use strict;

sub valid_package_name {
    my($string) = @_;
    $string =~ s/([^A-Za-z0-9\/])/sprintf("_%2x",unpack("C",$1))/eg;
    # second pass only for words starting with a digit
    $string =~ s|/(\d)|sprintf("/_%2x",unpack("C",$1))|eg;

    # Dress it up as a real package name
    $string =~ s|/|::|g;
    return $string;
}

sub packagize {
    my($file, $pkg) = @_;
    my $package = valid_package_name($pkg);

    local *FH;
    open FH, $file or print STDERR "$file: $!" and return;
    local($/) = undef;
    my $sub = <FH>;
    close FH;

    #wrap the code into a subroutine inside our unique package
    my $eval = qq{package $package; sub handler { $sub; }};
    {
	# hide our variables within this block
	my($file,$package,$sub);
	eval $eval;
    }
    if($@){
	print STDERR $@;
	return;
    }

    eval {$package->handler;};
    if($@){
	print STDERR $@;
	return;
    }

    return $package;
}

1;
